indexing

	description: "Converts strings to pointers and vice versa. VisualEiffel 4.1 specification"
	thanks: "The mico/E team for the idea."

	date: "$Date: 2003/01/09 $"
	revision: "$Revision: #4 $"

class

	EPX_STRING_HELPER


inherit

	ABSTRACT_STRING_HELPER


feature -- VisualEiffel specific conversions

	string_to_pointer (s: STRING): POINTER is
		do
			if s = Void then
				Result := default_pointer
			else
				Result := s.to_external
			end
		end

	pointer_to_string (p: POINTER): STRING is
		do
			create result.make_empty
			if p /= default_pointer then
				result.from_c (p)
			end
		end

	set_string_from_pointer (s: STRING; p: POINTER) is
		do
			if p = default_pointer then
				s.wipe_out
			else
				s.from_c (p)
			end
		end


feature -- string utilities that have different names per compiler...

	make_with_capacity (capacity: INTEGER): STRING is
			-- create a new string
		do
			create Result.make (capacity)
		end


end
