indexing

   description: "abstract IP address."

   author: "Berend de Boer"
   date: "$Date: 2002/02/06 $"
   revision: "$Revision: #2 $"


class

   SUS_IP4_ADDRESS


inherit

   SUS_IP_ADDRESS
      redefine
         out
      end

   SAPI_INET
      redefine
         out
      end


creation

   make_from_integer


feature -- creation

   make_from_integer (a_value: INTEGER) is
      do
         value := a_value
      end


feature -- public state

   value: INTEGER
         -- ip4 address as 32-bit integer


feature {NONE} -- private state

   assert_have_buffer is
         -- makes sure `buf' has a value and the correct contents
      do
         if buf = Void then
            create buf.allocate_and_clear (posix_in_addr_size)
         end
         posix_set_in_addr_s_addr (buf.ptr, value)
      end

   buf: STDC_BUFFER


feature -- friendly out

   out: STRING is
      do
         assert_have_buffer
         posix_set_in_addr_s_addr (buf.ptr, value)
         Result := sh.pointer_to_string (posix_inet_ntoa (buf.ptr))
      end


feature -- general ip address features

   family_type: INTEGER is
      do
         Result := AF_INET
      end

   ptr: POINTER is
         -- pointer to a in_addr structure
      do
         assert_have_buffer
         Result := buf.ptr
      ensure then
         has_pointer: Result /= default_pointer
      end


end
